xquery version "3.0";

module namespace app="http://exist-db.org/apps/preconferece/templates";

import module namespace templates="http://exist-db.org/xquery/templates" ;

import module namespace config="http://exist-db.org/xquery/apps/config" at "config.xqm";

(:~
 : This is a sample templating function. It will be called by the templating module if
 : it encounters an HTML element with a class attribute: class="app:test". The function
 : has to take exactly 3 parameters.
 : 
 : @param $node the HTML node with the class attribute which triggered this call
 : @param $model a map containing arbitrary data - used to pass information between template calls
 :)
declare function app:test($node as node(), $model as map(*)) {
    <p>Dummy template output generated by function app:test at {current-dateTime()}. The templating
        function was triggered by the class attribute <code>class="app:test"</code>.</p>
};

declare function app:presentations($node as node(), $model as map(*)) {
    for $presentation in doc($config:app-root || '/presentations.xml')//presentation
    return
        <tr>
            <td>{$presentation/date/text()}</td>
            <td>{$presentation/title/text()}</td>
            <td>{$presentation/presenter/text()}</td>
            <td><A HREF="{data($presentation/company/@url)}">{$presentation/company/text()}</A></td>
            <td>{ 
                    if ($presentation/video) 
                    then 
                        <A HREF="{ $presentation/video/text() }">Y</A>
                else 
                    ""
                }
            </td>
            <td>{ 
                    if ($presentation/slides) 
                    then 
                        <A HREF="{ $presentation/slides/text() }">Y</A>
                else 
                    ""
                }
            </td>
        </tr>
};